<?php
/**
 * Quotes Model
 *
 * @category  Magetop Extensions
 * @package   Magetop_Quotesystem
 * @author    Magetop Developer
 * @copyright Copyright (c) Magetop (https://www.magetop.com)
 * @license   https://www.magetop.com/license.html
 */

namespace Magetop\Quotesystem\Model;

use Magetop\Quotesystem\Api\Data\QuoteDetailsInterface;
use Magento\Framework\DataObject\IdentityInterface;
use \Magento\Framework\Model\AbstractModel;

class QuoteDetails extends AbstractModel implements QuoteDetailsInterface, IdentityInterface
{
    public const CACHE_TAG = 'mt_quote_details';

    /**
     * @var string
     */
    protected $_cacheTag = 'mt_quote_details';

    /**
     * Prefix of model events names
     *
     * @var string
     */
    protected $_eventPrefix = 'mt_quote_details';

    /**
     * Initialize resource model
     *
     * @return void
     */
    protected function _construct()
    {
        $this->_init(\Magetop\Quotesystem\Model\ResourceModel\QuoteDetails ::class);
    }
    /**
     * Return unique ID(s) for each object in system
     *
     * @return array
     */
    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getEntityId()];
    }

    /**
     * Get ID
     *
     * @return int|null
     */
    public function getEntityId()
    {
        return $this->getData(self::ENTITYID);
    }
    /**
     * Set ID
     *
     * @param int $entityId
     * @return \Magetop\Quotesystem\Model\QuoteDetails
     */
    public function setEntityId($entityId)
    {
        return $this->setData(self::ENTITYID, $entityId);
    }

    /**
     * Get Quote ID
     *
     * @return int|null
     */
    public function getQuoteId()
    {
        return $this->getData(self::QUOTEID);
    }
    /**
     * Set Quote ID
     *
     * @param int $quoteId
     * @return \Magetop\Quotesystem\Model\Quotes
     */
    public function setQuoteId($quoteId)
    {
        return $this->setData(self::QUOTEID, $quoteId);
    }

    /**
     * Get Website Id
     *
     * @return void
     */
    public function getWebsitesId()
    {
        return $this->getData(self::WEBSITESID);
    }

    /**
     * Set Website Id
     *
     * @param [type] $websiteId
     * @return void
     */
    public function setWebsitesId($websiteId)
    {
        return $this->setData(self::WEBSITESID, $websiteId);
    }
}
